<template>
  <header id="header">
    <b-navbar v-b-color-mode="'dark'" toggleable="lg" variant="dark">
      <b-navbar-brand href="/">
        <img
          :class="serviceProvider.logo.class"
          :src="serviceProvider.logo.location"
          :alt="serviceProvider.name"
          data-themekey="#"
        />
      </b-navbar-brand>

      <b-navbar-brand href="#">{{ $t("nav.brand") }}</b-navbar-brand>

      <b-navbar-toggle target="nav-collapse"></b-navbar-toggle>

      <b-collapse id="nav-collapse" is-nav>
        <b-navbar-nav class="centerNav" align="center">
          <CustomHeaderBanner
            v-if="
              $options.components && $options.components['CustomHeaderBanner']
            "
          />
        </b-navbar-nav>
        <b-navbar-nav class="ms-auto">
          <b-nav-item-dropdown right>
            <template #button-content>
              <i-bi-circle-half class="toggle-theme" />
              <span class="d-lg-none ms-2">{{ $t("nav.theme.toggle") }}</span>
            </template>
            <b-dropdown-item-button
              data-bs-theme-value="light"
              @click="setMode('light')"
              ><i-bi-sun-fill class="me-2 opacity-50 theme-icon" />
              {{ $t("nav.theme.light") }}
              <i-bi-check2 class="ms-auto d-none"
            /></b-dropdown-item-button>
            <b-dropdown-item-button
              data-bs-theme-value="dark"
              @click="setMode('dark')"
              ><i-bi-moon-stars-fill class="me-2 opacity-50 theme-icon" />
              {{ $t("nav.theme.dark") }}
              <i-bi-check2 class="ms-auto d-none"
            /></b-dropdown-item-button>
          </b-nav-item-dropdown>

          <b-navbar-brand href="https://nfdi4ing.de/" right>
            <img
              class="nfdi4ingLogo"
              src="@/assets/logo_nfdi4ing_white_quer.svg"
              alt="NFDI4Ing Logo"
              data-themekey="#"
            />
          </b-navbar-brand>
          <b-nav-item-dropdown text="?" right>
            <!-- Help -->
            <b-dropdown-item :href="$t('nav.url.extrasHelp')" target="_blank">
              {{ $t("nav.extrasHelp") }}
            </b-dropdown-item>
            <!-- Disclaimer -->
            <b-dropdown-item
              :href="$t('nav.url.extrasDisclaimer')"
              target="_blank"
            >
              {{ $t("nav.extrasDisclaimer") }}
            </b-dropdown-item>
            <!-- Imprint -->
            <b-dropdown-item
              :href="$t('nav.url.extrasImprint')"
              target="_blank"
            >
              {{ $t("nav.extrasImprint") }}
            </b-dropdown-item>
          </b-nav-item-dropdown>
          <b-nav-item-dropdown :text="$t('Lang')" right>
            <b-dropdown-item href="#" @click="changeLocale('de')">{{
              $t("DE")
            }}</b-dropdown-item>
            <b-dropdown-item href="#" @click="changeLocale('en')">{{
              $t("EN")
            }}</b-dropdown-item>
          </b-nav-item-dropdown>
        </b-navbar-nav>
      </b-collapse>
    </b-navbar>
  </header>
</template>

<script lang="ts">
import { defineComponent } from "vue";

import serviceProvider from "@/util/service-providers/service-provider";

import { useMainStore } from "@/store";

import EmptyComponent from "@/components/Layout/EmptyComponent.vue";
const CustomHeaderBanner =
  serviceProvider.uiElements.CustomHeaderBanner ?? EmptyComponent;

import type { Theme } from "@/types/types";

export default defineComponent({
  name: "AimsHeader",
  components: {
    CustomHeaderBanner,
  },
  props: {
    locale: {
      default: "en",
      type: String,
    },
  },
  setup() {
    const mainStore = useMainStore();

    return { mainStore };
  },
  data() {
    return {
      serviceProvider: serviceProvider,
    };
  },
  computed: {
    currentTheme(): Theme {
      return this.mainStore.currentTheme;
    },
  },
  mounted() {
    // From: https://getbootstrap.com/docs/5.3/customize/color-modes/#javascript
    const storedTheme = this.currentTheme;

    this.setTheme(this.getPreferredTheme(storedTheme));

    window.addEventListener("DOMContentLoaded", () => {
      this.showActiveTheme(this.getPreferredTheme(storedTheme));
    });
  },
  methods: {
    changeLocale(locale: string) {
      this.$emit("changeLocale", locale);
    },
    getPreferredTheme(storedTheme: Theme | null) {
      if (storedTheme) {
        return storedTheme;
      }

      return window.matchMedia("(prefers-color-scheme: dark)").matches
        ? "dark"
        : "light";
    },
    setMode(theme: Theme | null) {
      if (theme !== null) {
        this.mainStore.setTheme(theme);
        this.setTheme(theme);
        this.showActiveTheme(theme);
      }
    },
    setTheme(theme: Theme) {
      document.documentElement.dataset.bsTheme = theme;
    },
    showActiveTheme(theme: Theme) {
      const activeThemeIcon = document.querySelector(".theme-icon-active use");
      const buttonToActive = document.querySelector(
        `[data-bs-theme-value="${theme}"]`,
      );
      if (buttonToActive !== null && activeThemeIcon !== null) {
        const svgQuery = buttonToActive.querySelector("svg use");
        if (svgQuery !== null) {
          const svgOfActiveButton = svgQuery.getAttribute("href");

          if (svgOfActiveButton !== null) {
            for (const element of document.querySelectorAll(
              "[data-bs-theme-value]",
            )) {
              element.classList.remove("active");
            }

            buttonToActive.classList.add("active");
            activeThemeIcon.setAttribute("href", svgOfActiveButton);
          }
        }
      }
    },
  },
});
</script>

<style scoped>
.centerNav {
  height: 40px;
  width: 100%;
}
</style>

<style>
#header {
  width: 100%;
}
#header .navbar {
  max-width: 100%;
  padding-top: 0;
  padding-bottom: 0;
}
.navbar-nav .nav-item {
  padding-right: 0.5rem;
  padding-left: 0.5rem;
}
.navbar a img.aimsLogo {
  border: 0px;
  height: 34px;
  object-fit: cover;
  object-position: 0%;
  width: 100px;
  margin-top: -0.1rem;
}
.navbar a img.coscineLogo {
  border: 0px;
  object-fit: cover;
  object-position: 0%;
  width: 60px;
}
.toggle-theme {
  display: inline;
  vertical-align: text-bottom;
  width: 1.2em;
  height: 1.2em;
}
@media (min-width: 1400px) {
  .navbar a img.nfdi4ingLogo {
    border: 0px;
    object-position: 0%;
    width: 113px;
    height: 30px;
  }
}
@media (min-width: 1200px) and (max-width: 1399.98px) {
  .navbar a img.nfdi4ingLogo {
    border: 0px;
    object-position: 0%;
    width: 138px;
    height: 30px;
  }
}
@media (max-width: 1199.98px) {
  .navbar a img.nfdi4ingLogo {
    border: 0px;
    object-position: 0%;
    width: 156px;
    height: 30px;
  }
}
</style>
